﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private x2m As Xml2Map
	Private xmlstring As String
	Private resultmap As Map
	Private TreeView1 As TreeView
	Private btnload As Button
	Private btnshow As Button
	Public fchoose As FileChooser
	Public path As String
	Public filename As String
	Private lblpathfilename As Label
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Libraries documentation viewer")
	x2m.Initialize
	resultmap.Initialize
	fchoose.Initialize
End Sub
Private Sub btnload_Click
	TreeView1.Root.Children.Clear
	lblpathfilename.Text = ""
	fchoose.InitialDirectory = "C:\Program Files\Anywhere Software"
	fchoose.setExtensionFilter("File", Array As String("*.xml"))
	Dim fname As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname = "" Then Return
	path = fname.SubString2(0,fname.LastIndexOf("\")+1)
	filename = fname.SubString(fname.LastIndexOf("\")+1)
	lblpathfilename.Text = path & filename
	btnshow_Click
End Sub
Private Sub btnshow_Click
	If filename = "" Or path = "" Then
		xui.MsgboxAsync("The path or filename is empty.","Path and filename")
		Return
	End If
	TreeView1.Root.Children.Clear
	xmlstring = File.ReadString(path,filename)
	resultmap = x2m.Parse(xmlstring)
	Dim rootmap As Map = resultmap.Get("root")
	If rootmap.IsInitialized = False Then
		xui.MsgboxAsync("This doesn't seem to be a library documentation file.","Wrong file")
		Return
	End If
	For Each key In rootmap.Keys
		If key = "dependsOn" Then
			Dim dependstring As String = rootmap.Get(key)
			Dim ti As TreeItem
			ti.Initialize("ti","dependsOn:")
			TreeView1.Root.Children.Add(ti)
			If dependstring.StartsWith("[") Then
				Dim dependslst As List = rootmap.Get(key)
				add_sublist(dependslst,ti,"library: ")
			Else
				add_sub_one(dependstring,ti,"library: ")
			End If
		End If
		If key = "class" Then
			Dim rootstring As String = rootmap.Get(key)
			If rootstring.StartsWith("[") Then
				Dim classlst As List = rootmap.Get(key)
				For i = 0 To classlst.Size -1
					Dim item As Map = classlst.Get(i)
					Dim ti As TreeItem
					ti.Initialize("ti",item.Get("name"))
					TreeView1.Root.Children.Add(ti)
					Dim shortstring As String = item.Get("shortname")
					If shortstring = "" Or shortstring = "null" Then shortstring = "none" 
					Dim tis As TreeItem
					tis.Initialize("tis","shortname: " & shortstring)
					ti.Children.Add(tis)
					Dim commentstring As String = item.Get("comment")
					If commentstring = "" Or commentstring = "null" Then commentstring = "none"
					Dim tis As TreeItem
					tis.Initialize("tis","comment: " & commentstring)
					ti.Children.Add(tis)
					Dim eventstring As String = item.Get("event")
					If eventstring <> "" And eventstring <> "null" Then
						If eventstring.StartsWith("[") Then
							Dim eventlst As List = item.Get("event")
							add_sublist(eventlst,ti,"event: ")
						Else
							add_sub_one(eventstring,ti,"event: ")
						End If
					End If
					Dim despropstring As String = item.Get("designerProperty")
					If despropstring <> "" And despropstring <> "null" Then
						If despropstring.StartsWith("[") Then
							Dim desproplst As List = item.Get("designerProperty")
							add_sublist(desproplst,ti,"designerProperty: ")
						Else
							add_sub_one(despropstring,ti,"designerProperty: ")
						End If
					End If
					For Each itemkey In item.Keys
						If itemkey = "method" Or itemkey = "property" Or itemkey = "field" Then
							Dim tis As TreeItem
							tis.Initialize("tis",itemkey)
							ti.Children.Add(tis)
							Dim itemstring As String = item.Get(itemkey)
							If itemstring.StartsWith("[") Then
								Dim itemlst As List = item.Get(itemkey)
								add_list(itemlst, tis)
							Else
								Dim itemmap As Map = item.Get(itemkey)
								add_one(itemmap,tis)
							End If							
						End If
					Next
				Next
			Else
				Dim classmap As Map = rootmap.Get(key)
				Dim ti As TreeItem
				ti.Initialize("ti",classmap.Get("name"))
				TreeView1.Root.Children.Add(ti)
				Dim shortstring As String = classmap.Get("shortname")
				If shortstring = "" Or shortstring = "null" Then shortstring = "none"
				Dim tis As TreeItem
				tis.Initialize("tis","shortname: " & shortstring)
				ti.Children.Add(tis)
				Dim commentstring As String = classmap.Get("comment")
				If commentstring = "" Or commentstring = "null" Then commentstring = "none"
				Dim tis As TreeItem
				tis.Initialize("tis","comment: " & commentstring)
				ti.Children.Add(tis)
				Dim eventstring As String = classmap.Get("event")
				If eventstring <> "" And eventstring <> "null" Then
					If eventstring.StartsWith("[") Then
						Dim eventlst As List = classmap.Get("event")
						add_sublist(eventlst,ti,"event: ")
					Else
						add_sub_one(eventstring,ti,"event: ")
					End If
				End If
				Dim despropstring As String = classmap.Get("designerProperty")
				If despropstring <> "" And despropstring <> "null" Then
					If despropstring.StartsWith("[") Then
						Dim desproplst As List = classmap.Get("designerProperty")
						add_sublist(desproplst,ti,"designerProperty: ")
					Else
						add_sub_one(despropstring,ti,"designerProperty: ")
					End If
				End If
				For Each ckey In classmap.Keys
					If ckey = "method" Or ckey = "property" Or ckey = "field" Then
						Dim tis As TreeItem
						tis.Initialize("tis",ckey)
						ti.Children.Add(tis)
						Dim itemstring As String = classmap.Get(ckey)
						If itemstring.StartsWith("[") Then
							Dim itemlst As List = classmap.Get(ckey)
							add_list(itemlst, tis)
						Else
							Dim itemmap As Map = classmap.Get(ckey)
							add_one(itemmap,tis)
						End If
					End If
				Next
			End If
		End If
	Next
End Sub
Private Sub add_list(itemlst As List, tis As TreeItem)
	For j = 0 To itemlst.Size -1
		Dim mmap As Map = itemlst.Get(j)
		add_one(mmap,tis)
	Next
End Sub
Private Sub add_one(mmap As Map,tis As TreeItem)
	Dim namestring As String = mmap.Get("name")
	If namestring.Contains("DesignerName") Then
		Dim namemap As Map = mmap.Get("name")
		namestring = namemap.Get("Attributes").As(Map).Get("DesignerName")
	Else
		If namestring.Contains("Attributes") Then
			Dim namemap As Map = mmap.Get("name")
			Log(namestring)
			namestring = namemap.Get("Text")
		End If
	End If
	Dim tim As TreeItem
	tim.Initialize("tim",namestring)
	tis.Children.Add(tim)
	Dim commentstring As String = mmap.Get("comment")
	If commentstring = "" Or commentstring = "null" Then commentstring = "none"
	Dim tic As TreeItem
	tic.Initialize("tic","comment: " & commentstring)
	tim.Children.Add(tic)
	Dim returnstring As String = mmap.Get("returntype")
	If returnstring = "" Or returnstring = "null" Then returnstring = "none"
	Dim tic As TreeItem
	tic.Initialize("tic","return type: " & returnstring)
	tim.Children.Add(tic)
	Dim paramstring As String = mmap.Get("parameter")
	If paramstring <> "null" And paramstring <> "" Then
		Dim tic As TreeItem
		tic.Initialize("tic","parameters: ")
		tim.Children.Add(tic)
		If paramstring.StartsWith("[") Then
			Dim paramlst As List = mmap.Get("parameter")
			For p = 0 To paramlst.Size -1
				Dim pmap As Map = paramlst.Get(p)
				add_param(pmap,tic)
			Next
		Else
			Dim parammap As Map = mmap.Get("parameter")
			add_param(parammap,tic)
		End If
	End If
End Sub
Private Sub add_param(pmmap As Map,tic As TreeItem)
	Dim tip As TreeItem
	tip.Initialize("tip",pmmap.Get("name") & " as " & pmmap.Get("type"))
	tic.Children.Add(tip)
End Sub
Private Sub add_sublist(elst As List,ti As TreeItem,catname As String)
	Dim tis As TreeItem
	tis.Initialize("tis",catname)
	ti.Children.Add(tis)
	For d = 0 To elst.Size -1
		Dim tie As TreeItem
		tie.Initialize("tis",elst.Get(d))
		tis.Children.Add(tie)
	Next
End Sub
Private Sub add_sub_one(itemstring As String, ti As TreeItem,catname As String)
	Dim tis As TreeItem
	tis.Initialize("tis",catname)
	ti.Children.Add(tis)
	Dim tie As TreeItem
	tie.Initialize("tis",itemstring)
	tis.Children.Add(tie)
End Sub
